<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: HttpServer Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#friends">Friends</a> &#124;
<a href="classHttpServer-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">HttpServer Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a303273c5e6469b4ea4277668cd86ec67"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classHttpServer.html#a303273c5e6469b4ea4277668cd86ec67">HttpServer</a> ()</td></tr>
<tr class="separator:a303273c5e6469b4ea4277668cd86ec67"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aac086f847e37748c0c54f1e295baf2e4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classHttpServer.html#aac086f847e37748c0c54f1e295baf2e4">addPathHandler</a> (std::string method, std::string pathExpr, void(*webServerRequestHandler)(<a class="el" href="classHttpRequest.html">HttpRequest</a> *pHttpRequest, <a class="el" href="classHttpResponse.html">HttpResponse</a> *pHttpResponse))</td></tr>
<tr class="memdesc:aac086f847e37748c0c54f1e295baf2e4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Register a handler for a path.  <a href="#aac086f847e37748c0c54f1e295baf2e4">More...</a><br /></td></tr>
<tr class="separator:aac086f847e37748c0c54f1e295baf2e4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a57af2880e0ac2d49cd0ca8d35e662b4d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classHttpServer.html#a57af2880e0ac2d49cd0ca8d35e662b4d">addPathHandler</a> (std::string method, std::regex *pRegex, void(*webServerRequestHandler)(<a class="el" href="classHttpRequest.html">HttpRequest</a> *pHttpRequest, <a class="el" href="classHttpResponse.html">HttpResponse</a> *pHttpResponse))</td></tr>
<tr class="memdesc:a57af2880e0ac2d49cd0ca8d35e662b4d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Register a handler for a path.  <a href="#a57af2880e0ac2d49cd0ca8d35e662b4d">More...</a><br /></td></tr>
<tr class="separator:a57af2880e0ac2d49cd0ca8d35e662b4d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a284988ba72075a9abc3af5499ed9ed56"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classHttpServer.html#a284988ba72075a9abc3af5499ed9ed56">getClientTimeout</a> ()</td></tr>
<tr class="memdesc:a284988ba72075a9abc3af5499ed9ed56"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get current socket's timeout for new connections.  <a href="#a284988ba72075a9abc3af5499ed9ed56">More...</a><br /></td></tr>
<tr class="separator:a284988ba72075a9abc3af5499ed9ed56"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac771b9fe9b2d825df7231ff0dee7e253"><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classHttpServer.html#ac771b9fe9b2d825df7231ff0dee7e253">getFileBufferSize</a> ()</td></tr>
<tr class="memdesc:ac771b9fe9b2d825df7231ff0dee7e253"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the size of the file buffer. When serving up a file from the file system, we can't afford to read the whole file into RAM before sending it. As such, we must read the file in chunks. The buffer size is the size of a chunk to be transmitted before the next chunk is read.  <a href="#ac771b9fe9b2d825df7231ff0dee7e253">More...</a><br /></td></tr>
<tr class="separator:ac771b9fe9b2d825df7231ff0dee7e253"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af4a61a2ac8da8773025da0d2fde1aef5"><td class="memItemLeft" align="right" valign="top">uint16_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classHttpServer.html#af4a61a2ac8da8773025da0d2fde1aef5">getPort</a> ()</td></tr>
<tr class="memdesc:af4a61a2ac8da8773025da0d2fde1aef5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the port number on which the HTTP Server is listening.  <a href="#af4a61a2ac8da8773025da0d2fde1aef5">More...</a><br /></td></tr>
<tr class="separator:af4a61a2ac8da8773025da0d2fde1aef5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa4dfccf48a9c721ca8bb00d61f7b4e13"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classHttpServer.html#aa4dfccf48a9c721ca8bb00d61f7b4e13">getRootPath</a> ()</td></tr>
<tr class="memdesc:aa4dfccf48a9c721ca8bb00d61f7b4e13"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the current root path.  <a href="#aa4dfccf48a9c721ca8bb00d61f7b4e13">More...</a><br /></td></tr>
<tr class="separator:aa4dfccf48a9c721ca8bb00d61f7b4e13"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad3d17b4df0252445a2ed4f0f8ea06201"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classHttpServer.html#ad3d17b4df0252445a2ed4f0f8ea06201">getSSL</a> ()</td></tr>
<tr class="memdesc:ad3d17b4df0252445a2ed4f0f8ea06201"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return whether or not we are using SSL.  <a href="#ad3d17b4df0252445a2ed4f0f8ea06201">More...</a><br /></td></tr>
<tr class="separator:ad3d17b4df0252445a2ed4f0f8ea06201"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad70784b8f9484a16bf74c34413a24d4d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classHttpServer.html#ad70784b8f9484a16bf74c34413a24d4d">setClientTimeout</a> (uint32_t timeout)</td></tr>
<tr class="memdesc:ad70784b8f9484a16bf74c34413a24d4d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set different socket timeout for new connections.  <a href="#ad70784b8f9484a16bf74c34413a24d4d">More...</a><br /></td></tr>
<tr class="separator:ad70784b8f9484a16bf74c34413a24d4d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aab1f060cbbaaeaa2b75f812e866e6ff0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classHttpServer.html#aab1f060cbbaaeaa2b75f812e866e6ff0">setDirectoryListing</a> (bool use)</td></tr>
<tr class="memdesc:aab1f060cbbaaeaa2b75f812e866e6ff0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set whether or not we will list directories.  <a href="#aab1f060cbbaaeaa2b75f812e866e6ff0">More...</a><br /></td></tr>
<tr class="separator:aab1f060cbbaaeaa2b75f812e866e6ff0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7686343c224f5e8a62f5f07de481345d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classHttpServer.html#a7686343c224f5e8a62f5f07de481345d">setFileBufferSize</a> (size_t fileBufferSize)</td></tr>
<tr class="memdesc:a7686343c224f5e8a62f5f07de481345d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the size of the file buffer. When serving up a file from the file system, we can't afford to read the whole file into RAM before sending it. As such, we must read the file in chunks. The buffer size is the size of a chunk to be transmitted before the next chunk is read.  <a href="#a7686343c224f5e8a62f5f07de481345d">More...</a><br /></td></tr>
<tr class="separator:a7686343c224f5e8a62f5f07de481345d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a141a7cde0ccf11ff395df0faef79d6a5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classHttpServer.html#a141a7cde0ccf11ff395df0faef79d6a5">setRootPath</a> (std::string path)</td></tr>
<tr class="memdesc:a141a7cde0ccf11ff395df0faef79d6a5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the root path for URL file mapping.  <a href="#a141a7cde0ccf11ff395df0faef79d6a5">More...</a><br /></td></tr>
<tr class="separator:a141a7cde0ccf11ff395df0faef79d6a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a79bbf11522346b2eae709e6112b130c2"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classHttpServer.html#a79bbf11522346b2eae709e6112b130c2">start</a> (uint16_t portNumber, bool useSSL=false)</td></tr>
<tr class="memdesc:a79bbf11522346b2eae709e6112b130c2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Start the HTTP server listening. We start an instance of the HTTP server listening. A new task is spawned to perform this work in the back ground.  <a href="#a79bbf11522346b2eae709e6112b130c2">More...</a><br /></td></tr>
<tr class="separator:a79bbf11522346b2eae709e6112b130c2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aad9c63d3f8cda248e3c87067ac3ac5a5"><td class="memItemLeft" align="right" valign="top"><a id="aad9c63d3f8cda248e3c87067ac3ac5a5"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classHttpServer.html#aad9c63d3f8cda248e3c87067ac3ac5a5">stop</a> ()</td></tr>
<tr class="memdesc:aad9c63d3f8cda248e3c87067ac3ac5a5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Shutdown the HTTP server. <br /></td></tr>
<tr class="separator:aad9c63d3f8cda248e3c87067ac3ac5a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:a3cc3306861979ff7b3b2c03500780072"><td class="memItemLeft" align="right" valign="top"><a id="a3cc3306861979ff7b3b2c03500780072"></a>
class&#160;</td><td class="memItemRight" valign="bottom"><b>HttpServerTask</b></td></tr>
<tr class="separator:a3cc3306861979ff7b3b2c03500780072"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aae91499d85b5a2d8fbe7c9439fe78fcf"><td class="memItemLeft" align="right" valign="top"><a id="aae91499d85b5a2d8fbe7c9439fe78fcf"></a>
class&#160;</td><td class="memItemRight" valign="bottom"><b>WebSocket</b></td></tr>
<tr class="separator:aae91499d85b5a2d8fbe7c9439fe78fcf"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a303273c5e6469b4ea4277668cd86ec67"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a303273c5e6469b4ea4277668cd86ec67">&#9670;&nbsp;</a></span>HttpServer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">HttpServer::HttpServer </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Constructor for HTTP Server </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="aac086f847e37748c0c54f1e295baf2e4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aac086f847e37748c0c54f1e295baf2e4">&#9670;&nbsp;</a></span>addPathHandler() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HttpServer::addPathHandler </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>method</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>path</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void(*)(<a class="el" href="classHttpRequest.html">HttpRequest</a> *pHttpRequest, <a class="el" href="classHttpResponse.html">HttpResponse</a> *pHttpResponse)&#160;</td>
          <td class="paramname"><em>handler</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Register a handler for a path. </p>
<p>When a browser request arrives, the request will contain a method (GET, POST, etc) and a path to be accessed. Using this method we can register a regular expression and, if the incoming method and path match the expression, the corresponding handler will be called.</p>
<p>Example: </p><div class="fragment"><div class="line"><span class="keyword">static</span> <span class="keywordtype">void</span> handle_REST_WiFi(WebServer::HttpRequest *pRequest, WebServer::HttpResponse *pResponse) {</div><div class="line"> ...</div><div class="line">}</div><div class="line"></div><div class="line">webServer.addPathHandler(<span class="stringliteral">&quot;GET&quot;</span>, <span class="stringliteral">&quot;/ESP32/WiFi&quot;</span>, handle_REST_WiFi);</div></div><!-- fragment --><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">method</td><td>The method being used for access ("GET", "POST" etc). </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">path</td><td>The plain path being accessed. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">handler</td><td>The callback function to be invoked when a request arrives. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a57af2880e0ac2d49cd0ca8d35e662b4d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a57af2880e0ac2d49cd0ca8d35e662b4d">&#9670;&nbsp;</a></span>addPathHandler() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HttpServer::addPathHandler </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>method</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::regex *&#160;</td>
          <td class="paramname"><em>pathExpr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void(*)(<a class="el" href="classHttpRequest.html">HttpRequest</a> *pHttpRequest, <a class="el" href="classHttpResponse.html">HttpResponse</a> *pHttpResponse)&#160;</td>
          <td class="paramname"><em>handler</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Register a handler for a path. </p>
<p>When a browser request arrives, the request will contain a method (GET, POST, etc) and a path to be accessed. Using this method we can register a regular expression and, if the incoming method and path match the expression, the corresponding handler will be called.</p>
<p>Example: </p><div class="fragment"><div class="line"><span class="keyword">static</span> <span class="keywordtype">void</span> handle_REST_WiFi(WebServer::HttpRequest *pRequest, WebServer::HttpResponse *pResponse) {</div><div class="line"> ...</div><div class="line">}</div><div class="line"></div><div class="line">webServer.addPathHandler(<span class="stringliteral">&quot;GET&quot;</span>, <span class="stringliteral">&quot;\\/ESP32\\/WiFi&quot;</span>, handle_REST_WiFi);</div></div><!-- fragment --><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">method</td><td>The method being used for access ("GET", "POST" etc). </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">pathExpr</td><td>The path being accessed. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">handler</td><td>The callback function to be invoked when a request arrives. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a284988ba72075a9abc3af5499ed9ed56"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a284988ba72075a9abc3af5499ed9ed56">&#9670;&nbsp;</a></span>getClientTimeout()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t HttpServer::getClientTimeout </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get current socket's timeout for new connections. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">use</td><td>Set to true to enable directory listing. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ac771b9fe9b2d825df7231ff0dee7e253"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac771b9fe9b2d825df7231ff0dee7e253">&#9670;&nbsp;</a></span>getFileBufferSize()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t HttpServer::getFileBufferSize </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the size of the file buffer. When serving up a file from the file system, we can't afford to read the whole file into RAM before sending it. As such, we must read the file in chunks. The buffer size is the size of a chunk to be transmitted before the next chunk is read. </p>
<dl class="section return"><dt>Returns</dt><dd>The file buffer size. </dd></dl>

</div>
</div>
<a id="af4a61a2ac8da8773025da0d2fde1aef5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af4a61a2ac8da8773025da0d2fde1aef5">&#9670;&nbsp;</a></span>getPort()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint16_t HttpServer::getPort </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the port number on which the HTTP Server is listening. </p>
<dl class="section return"><dt>Returns</dt><dd>The port number on which the HTTP server is listening. </dd></dl>

</div>
</div>
<a id="aa4dfccf48a9c721ca8bb00d61f7b4e13"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa4dfccf48a9c721ca8bb00d61f7b4e13">&#9670;&nbsp;</a></span>getRootPath()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string HttpServer::getRootPath </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the current root path. </p>
<dl class="section return"><dt>Returns</dt><dd>The current root path. </dd></dl>

</div>
</div>
<a id="ad3d17b4df0252445a2ed4f0f8ea06201"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad3d17b4df0252445a2ed4f0f8ea06201">&#9670;&nbsp;</a></span>getSSL()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool HttpServer::getSSL </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Return whether or not we are using SSL. </p>
<dl class="section return"><dt>Returns</dt><dd>True if we are using SSL. </dd></dl>

</div>
</div>
<a id="ad70784b8f9484a16bf74c34413a24d4d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad70784b8f9484a16bf74c34413a24d4d">&#9670;&nbsp;</a></span>setClientTimeout()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HttpServer::setClientTimeout </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>timeout</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set different socket timeout for new connections. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">use</td><td>Set to true to enable directory listing. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aab1f060cbbaaeaa2b75f812e866e6ff0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aab1f060cbbaaeaa2b75f812e866e6ff0">&#9670;&nbsp;</a></span>setDirectoryListing()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HttpServer::setDirectoryListing </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>use</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set whether or not we will list directories. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">use</td><td>Set to true to enable directory listing. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a7686343c224f5e8a62f5f07de481345d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7686343c224f5e8a62f5f07de481345d">&#9670;&nbsp;</a></span>setFileBufferSize()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HttpServer::setFileBufferSize </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>fileBufferSize</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the size of the file buffer. When serving up a file from the file system, we can't afford to read the whole file into RAM before sending it. As such, we must read the file in chunks. The buffer size is the size of a chunk to be transmitted before the next chunk is read. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">fileBufferSize</td><td>How large should the file buffer size be? </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a141a7cde0ccf11ff395df0faef79d6a5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a141a7cde0ccf11ff395df0faef79d6a5">&#9670;&nbsp;</a></span>setRootPath()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HttpServer::setRootPath </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>path</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the root path for URL file mapping. </p>
<p>When a browser requests a file, it uses the address form:</p>
<div class="fragment"><div class="line">http://&lt;host&gt;:&lt;port&gt;/&lt;path&gt;</div></div><!-- fragment --><p>The path part can be considered the path to where the file should be retrieved on the file system available to the web server. Typically, we want a directory structure on the file system to host the web served files and not expose the whole file system. Using this method we specify the root directory from which the files will be served.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">path</td><td>The root path on the file system. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a79bbf11522346b2eae709e6112b130c2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a79bbf11522346b2eae709e6112b130c2">&#9670;&nbsp;</a></span>start()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void HttpServer::start </td>
          <td>(</td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>portNumber</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>useSSL</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Start the HTTP server listening. We start an instance of the HTTP server listening. A new task is spawned to perform this work in the back ground. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">portNumber</td><td>The port number on which the HTTP server should listen. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">useSSL</td><td>Should we use SSL? </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="HttpServer_8h_source.html">HttpServer.h</a></li>
<li>HttpServer.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
